# coding: utf-8

#  Copyright (c) 2022 Macrometa Corp All rights reserved.

from typing import Dict, List  # noqa: F401

from fastapi import (  # noqa: F401
    APIRouter,
    Body,
    Cookie,
    Depends,
    Form,
    Header,
    Path,
    Query,
    Response,
    Security,
    status,
)

from c8cws.models.extra_models import TokenModel  # noqa: F401
from c8cws.models.request import Request

router = APIRouter(prefix='/_api', tags=['workflows'])


@router.post(
    "/tenant/{tenant}/fabric/{fabric}/workflows",
    responses={
        200: {"description": "OK"},
        400: {"description": ""},
        401: {"description": ""},
    },
    tags=["workflows"],
    summary="Submit new connector workflow.",
    response_model_by_alias=True,
)
async def create_workflow(
        fabric: str = Path(None, description="Fabric name of the workflow"),
        tenant: str = Path(None, description="Tenant name of the workflow"),
        request: Request = Body(None,
                                description="Connector information such as connectorName, connector repository URL, etc..."),
) -> None:
    """"""
    ...


@router.delete(
    "/tenant/{tenant}/fabric/{fabric}/workflows/{id}",
    responses={
        200: {"description": "OK"},
        401: {"description": ""},
        404: {"description": ""},
    },
    tags=["workflows"],
    summary="Terminate and remove a workflow.",
    response_model_by_alias=True,
)
async def delete_workflow(
        tenant: str = Path(None, description="Tenant name of the workflow"),
        fabric: str = Path(None, description="Fabric name of the workflow"),
        id: str = Path(None, description="ID of the workflow"),
) -> None:
    """"""
    ...


@router.get(
    "/tenant/{tenant}/fabric/{fabric}/workflows",
    responses={
        200: {"description": "OK"},
        401: {"description": ""},
        404: {"description": ""},
    },
    tags=["workflows"],
    summary="Get the list of running connector workflows for a given tenant and fabric.",
    response_model_by_alias=True,
)
async def get_workflows(
        fabric: str = Path(None, description="Fabric name of the workflow"),
        tenant: str = Path(None, description="Tenant name of the workflow"),
) -> None:
    """"""
    ...
